<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceBookingInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceBookingInfo extends AbstractStructArrayBase
{
    /**
     * The ServiceBookingInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceBookingInfo[]
     */
    public $ServiceBookingInfo;
    /**
     * Constructor method for ArrayOfJP_ServiceBookingInfo
     * @uses ArrayOfJP_ServiceBookingInfo::setServiceBookingInfo()
     * @param \StructType\JP_ServiceBookingInfo[] $serviceBookingInfo
     */
    public function __construct(array $serviceBookingInfo = array())
    {
        $this
            ->setServiceBookingInfo($serviceBookingInfo);
    }
    /**
     * Get ServiceBookingInfo value
     * @return \StructType\JP_ServiceBookingInfo[]|null
     */
    public function getServiceBookingInfo()
    {
        return $this->ServiceBookingInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceBookingInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceBookingInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceBookingInfoForArrayConstraintsFromSetServiceBookingInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ServiceBookingInfoServiceBookingInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceBookingInfoServiceBookingInfoItem instanceof \StructType\JP_ServiceBookingInfo) {
                $invalidValues[] = is_object($arrayOfJP_ServiceBookingInfoServiceBookingInfoItem) ? get_class($arrayOfJP_ServiceBookingInfoServiceBookingInfoItem) : sprintf('%s(%s)', gettype($arrayOfJP_ServiceBookingInfoServiceBookingInfoItem), var_export($arrayOfJP_ServiceBookingInfoServiceBookingInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceBookingInfo property can only contain items of type \StructType\JP_ServiceBookingInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceBookingInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceBookingInfo[] $serviceBookingInfo
     * @return \ArrayType\ArrayOfJP_ServiceBookingInfo
     */
    public function setServiceBookingInfo(array $serviceBookingInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceBookingInfoArrayErrorMessage = self::validateServiceBookingInfoForArrayConstraintsFromSetServiceBookingInfo($serviceBookingInfo))) {
            throw new \InvalidArgumentException($serviceBookingInfoArrayErrorMessage, __LINE__);
        }
        $this->ServiceBookingInfo = $serviceBookingInfo;
        return $this;
    }
    /**
     * Add item to ServiceBookingInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceBookingInfo $item
     * @return \ArrayType\ArrayOfJP_ServiceBookingInfo
     */
    public function addToServiceBookingInfo(\StructType\JP_ServiceBookingInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceBookingInfo) {
            throw new \InvalidArgumentException(sprintf('The ServiceBookingInfo property can only contain items of type \StructType\JP_ServiceBookingInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceBookingInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceBookingInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceBookingInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceBookingInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceBookingInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceBookingInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceBookingInfo
     */
    public function getAttributeName()
    {
        return 'ServiceBookingInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_ServiceBookingInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
